package com.engine.organization.entity.company.param;

import com.engine.organization.common.BaseQueryParam;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @description:
 * @author:dxfeng
 * @createTime: 2022/05/16
 * @version: 1.0
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class CompSearchParam extends BaseQueryParam {

    /**
     * 主键
     */
    private Long id;

    /**
     * 编号
     */
    private String compNo;

    /**
     * 名称
     */
    private String compName;

    /**
     * 简称
     */
    private String compNameShort;

    /**
     * 上级公司
     */
    private Long parentCompany;
    private Long ecCompany;

    /**
     * 组织机构代码
     */
    private String orgCode;

    /**
     * 行业
     */
    private Integer industry;

    /**
     * 负责人
     */
    private Integer compPrincipal;

    /**
     * 说明
     */
    private String description;

    /**
     * 禁用标记
     */
    private Boolean forbiddenTag;
}
