package com.engine.organization.entity.employee.vo;

/**
 * @description:
 * @author:dxfeng
 * @createTime: 2022/05/31
 * @version: 1.0
 */

import com.cloudstore.eccom.pc.table.WeaTableType;
import com.engine.organization.annotation.OrganizationTable;
import com.engine.organization.annotation.OrganizationTableColumn;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@OrganizationTable(pageId = "80e7830c-18e8-4e14-8241-18821195ef31",
        fields = "t.id," +
                "t.last_name," +
                "t.mobile," +
                "t.company_start_date," +
                "t.sex",
        fromSql = "FROM jcl_org_hrmresource t ",
        orderby = "id",
        primarykey = "id",
        tableType = WeaTableType.NONE
)
public class EmployeeTableVO {

    @OrganizationTableColumn(column = "id", display = false)
    private Long id;

    @OrganizationTableColumn(text = "姓名", width = "25%", column = "last_name")
    private String lastname;

    @OrganizationTableColumn(text = "性别", width = "25%", column = "sex",transmethod = "com.engine.organization.transmethod.JobTransMethod.getSexName")
    private String sex;

    @OrganizationTableColumn(text = "手机", width = "25%", column = "mobile")
    private String mobile;

    @OrganizationTableColumn(text = "入职日期", width = "25%", column = "company_start_date")
    private String companystartdate;


}
