package com.engine.organization.entity.job.dto;

import com.cloudstore.eccom.pc.table.WeaTableType;
import com.engine.organization.annotation.OrganizationTable;
import com.engine.organization.annotation.TableTitle;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * @description:
 * @author:dxfeng
 * @createTime: 2022/05/30
 * @version: 1.0
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@OrganizationTable(pageId = "0efea835-dfc5-11ec-a09e-00e04c680716",
        tableType = WeaTableType.NONE)
public class JobListDTO {
    /**
     * 主键
     */
    private Long id;
    /**
     * 是否被引用
     */
    private Integer isUsed;
    /**
     * 名称
     */
    @TableTitle(title = "名称", dataIndex = "jobName", key = "jobName",width = "150")
    private String jobName;
    /**
     * 编号
     */
    @TableTitle(title = "编号", dataIndex = "jobNo", key = "jobNo")
    private String jobNo;
    /**
     * 所属分部
     */
    @TableTitle(title = "所属分部", dataIndex = "compName", key = "compName")
    private String compName;
    /**
     * 所属部门
     */
    @TableTitle(title = "所属部门", dataIndex = "deptName", key = "deptName")
    private String deptName;
    /**
     * 岗位序列
     */
    @TableTitle(title = "岗位序列", dataIndex = "sequenceName", key = "sequenceName")
    private String sequenceName;
    /**
     * 等级方案
     */
    @TableTitle(title = "等级方案", dataIndex = "schemeName", key = "schemeName")
    private String schemeName;
    /**
     * 上级岗位
     */
    // 上级岗位，暂不使用
    //@TableTitle(title = "上级岗位", dataIndex = "parentJobName", key = "parentJobName")
    private String parentJobName;
    private Long parentJob;
    private Long parentComp;
    /**
     * 是否关键岗
     */
    @TableTitle(title = "是否关键岗", dataIndex = "isKey", key = "isKey")
    private String isKey;

    /**
     * 显示顺序
     */
    @TableTitle(title = "显示顺序", dataIndex = "showOrder", key = "showOrder", sorter = true)
    private Integer showOrder;

    /**
     * 禁用标记
     */
    @TableTitle(title = "是否启用", dataIndex = "forbiddenTag", key = "forbiddenTag")
    private Integer forbiddenTag;

    /**
     * 操作列
     */
    @TableTitle(title = "", dataIndex = "operate", key = "operate")
    private String operate;
    /**
     * 子节点
     */
    private List<JobListDTO> children;
}
