package com.engine.organization.entity.job.vo;

import com.cloudstore.eccom.pc.table.WeaTableType;
import com.engine.organization.annotation.OrganizationTable;
import com.engine.organization.annotation.OrganizationTableColumn;
import com.engine.organization.annotation.OrganizationTableOperate;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author:dxfeng
 * @createTime: 2022/07/15
 * @version: 1.0
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@OrganizationTable(pageId = "98e9c62f-cd12-11ec-a15f-00ffcbed7123",
        fields = "t.id, t.job_no, t.job_name as name, t.sequence_id, t.scheme_id , t.grade_id , t.level_id",
        fromSql = "FROM jcl_org_job t ",
        orderby = "id",
        sortway = "asc",
        primarykey = "id",
        operates = {
                @OrganizationTableOperate(index = "0", text = "编辑"),
                @OrganizationTableOperate(index = "1", text = "删除")
        },
        tableType = WeaTableType.CHECKBOX
)
public class JobBrowserVO {

    @OrganizationTableColumn(text = "标识", width = "25%", column = "id", display = false)
    private Long id;

    @OrganizationTableColumn(text = "编号", width = "25%", column = "job_no")
    private String jobNo;

    @OrganizationTableColumn(text = "岗位名称", width = "25%", column = "name")
    private String jobName;

    @OrganizationTableColumn(text = "等级方案", width = "25%", column = "scheme_id", transmethod = "com.engine.organization.transmethod.JobTransMethod.getSchemeName")
    private String schemeName;
    @OrganizationTableColumn(text = "职等", width = "25%", column = "level_id", transmethod = "com.engine.organization.transmethod.JobTransMethod.getLevelName")
    private String levelName;
    @OrganizationTableColumn(text = "职级", width = "25%", column = "grade_id", transmethod = "com.engine.organization.transmethod.JobTransMethod.getGradeName")
    private String gradeName;
    @OrganizationTableColumn(text = "岗位序列", width = "25%", column = "sequence_id", transmethod = "com.engine.organization.transmethod.JobTransMethod.getSequenceName")
    private String sequenceName;
}
